import type { OASDocument, SchemaObject } from '../rmoas.types';
import type Operation from '../operation';
export declare type SchemaWrapper = {
    $schema?: string;
    type: string;
    label?: string;
    schema: SchemaObject;
    deprecatedProps?: SchemaWrapper;
};
/**
 * The order of this object determines how they will be sorted in the compiled JSON Schema
 * representation.
 *
 * @see {@link https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.3.md#parameterObject}
 * @see {@link https://github.com/OAI/OpenAPI-Specification/blob/main/versions/3.1.0.md#parameterObject}
 */
export declare const types: Record<keyof OASDocument, string>;
export default function getParametersAsJsonSchema(operation: Operation, api: OASDocument, opts?: {
    globalDefaults?: Record<string, unknown>;
    mergeIntoBodyAndMetadata?: boolean;
    retainDeprecatedProperties?: boolean;
}): SchemaWrapper[];
