const db = require('../models/bootstrap')
var Json2csvParser = require('json2csv').Parser;
const Op = db.Sequelize.Op;

const Analytics = db.analytics;
const Campaign = db.campaign;


getStats = async (req, res) => {
    try {
        const camp_id = req.params.camp_id;
        // res.send({ "camp_id": camp_id })
        // const response = await Analytics.findAll({
        //     include: [{
        //         model: Campaign,
        //         required: true,
        //         attributes: [
        //             'name'
        //         ]
        //     }],
        //     attributes: [
        //         [db.sequelize.fn('sum', sequelize.col('total_play')), 'total_plays'],
        //         [db.sequelize.fn('sum', sequelize.col('click_action')), 'total_clicks'],
        //         [db.sequelize.fn('sum', sequelize.col('skip_count')), 'total_skips'],
        //         [db.sequelize.fn('sum', sequelize.col('full_watch')), 'total_full_watch'],
        //         [db.sequelize.fn('count', sequelize.col('camp_id')), 'unique_visitors'],
        //         'email'
        //     ],
        //     where: {
        //         camp_id: camp_id
        //     }
        // })


        const response = await Campaign.findOne({
            include: [{
                model: Analytics,
                required: true,
                attributes: [
                    [db.sequelize.fn('sum', sequelize.col('total_play')), 'total_plays'],
                    [db.sequelize.fn('sum', sequelize.col('click_action')), 'total_clicks'],
                    [db.sequelize.fn('sum', sequelize.col('skip_count')), 'total_skips'],
                    [db.sequelize.fn('sum', sequelize.col('full_watch')), 'total_full_watch'],
                    [db.sequelize.fn('count', sequelize.col('camp_id')), 'unique_visitors'],
                    'email'
                ]
            }],
            attributes: [

                'name'
            ],
            where: {
                id: camp_id
            }
        })





        if (!response) {
            res.send({ status: 404 })

        }

        res.send({ status: 200, body: response })




    } catch (error) {
        console.log(error)
    }
}


exportCSV = async (req, res) => {
    try {
        const camp_id = req.params.camp_id;

        const users = await Analytics.findAll({
            attributes: ['full_name', 'contact_no', 'email', 'company', 'ip_address'],
            where: {
                camp_id
            }
        })

        // console.log(users);
        if (users.length <= 0) return res.send({ "body": "No data found" })




        const jsonUsers = JSON.parse(JSON.stringify(users));
        const csvFields = ['full_name', 'contact_no', 'email', 'company', 'ip_address'];
        const json2csvParser = new Json2csvParser({ csvFields });
        const csv = json2csvParser.parse(jsonUsers);


        res.setHeader("Content-Type", "text/csv");
        res.setHeader("Content-Disposition", `attachment; filename=${camp_id}.csv`);
        res.status(200).end(csv);


    } catch (error) {
        console.log(error)
    }
}


module.exports = {
    getStats,
    exportCSV
}