const serialize = require('serialize-javascript');
const db = require('../models/bootstrap')

const Op = db.Sequelize.Op;
const Setting = db.setting;
insertApiKeys = async (req, res) => {

    try {
        const type = req.body.type;

        delete req.body.type
        const meta_data = serialize(req.body);
        const user_id = req._user_id;
        const meta_type = type;

        const insertData = await Setting.create({
            meta_type, user_id, meta_data
        })

        if (insertData) {
            res.send({ status: 200, message: 'Successfully inserted' })
        }
        // res.send("Hello")


    } catch (error) {
        res.send(error.message)
    }

}


fetchKeys = async (req, res) => {
    try {
        // console.log(req._user_id)
        const response = await Setting.findAll({
            where: { user_id: req._user_id },
            attributes: ['id', 'meta_type', 'meta_data']
        })

        if (!response) return res.send({ status: 402, body: null })

        if (response) return res.send({ status: 200, body: response })
        // res.send({ id: req._user_id })
    } catch (error) {
        res.send({ status: 500, message: error.message })
    }
}


updateApiKeys = async (req, res) => {
    try {
        const type = req.body.type;

        delete req.body.type
        const meta_data = serialize(req.body);
        const user_id = req._user_id;
        const meta_type = type;

        const response = await Setting.update({ meta_data: meta_data }, { where: { meta_type: meta_type, user_id: user_id } })

        if (!response) return res.status(401).send({ message: 'Unable to send' })

        res.send({ message: 'Successfully Updated' })


    } catch (error) {
        res.send(error.message)
    }
}

updateDetails = async (req, res) => {
    try {
        const type = req.body.type;
        delete req.body.type
        const meta_data = serialize(req.body);
        const user_id = req._user_id;
        const meta_type = type;

        const checkData = await Setting.findOne({
            where: {
                user_id: req._user_id,
                meta_type,
            }
        })

        if (checkData) {
            const response = await Setting.update({ meta_data: meta_data }, { where: { meta_type, user_id } })

            if (!response) return res.status(401).send({ message: 'Unable to update' })

            res.send({ status: 200, message: 'Successfully Updated' })

        } else {
            const insertData = await Setting.create({
                meta_type, user_id, meta_data
            })

            if (!insertData) return res.status(401).send({ message: 'Unable to save data' })

            if (insertData) res.send({ status: 200, message: 'Successfully inserted' })

        }

    } catch (error) {
        res.send(error.message)
    }
}


fetchTutorials = (req, res) => {
    try {
        const tut = [
            {
                name: "How To Create A Campaign Using A Video Template?",
                url: "https://player.vimeo.com/video/718794592",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Create+A+Campaign+Using+A+Video+Template.pdf"
            },
            {
                name: "How To Create A Campaign Using Import Video (Upload & YouTube)?",
                url: "https://player.vimeo.com/video/718794650",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Create+A+Campaign+Using+Import+Video+Feature.pdf"
            },
            {
                name: "How To Create A Video Using A Video Template?",
                url: "https://player.vimeo.com/video/718794699",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Create+A+Video+Using+A+Video+Template.pdf"
            },
            {
                name: "How To Edit Slides Scenes In A Template?",
                url: "",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Edit+Slides+Scenes+In+A+Template.pdf"
            },
            {
                name:"How To Edit Or Configure The Draft Campaign?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Edit+A+Campaign+In+Draft.pdf"
            },
            {
                name:"How To Add New Slides And Delete Slides?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Add+And+Delete+Scenes+In+A+Template.pdf"
            },
            {
                name:"How To Clone A Campaign?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Clone+A+Campaign.pdf"
            },
            {
                name:"Overview of Personalize Video Feature",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Personalize+A+Video+-+I.pdf"
            },
            {
                name:"How to add CTA Link in video action?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+9+Video+Actions+To+Personalize+-+1+CTA+LINK.pdf"
            },
            {
                name:"How to add Custom CTA Link in video action?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+9+Video+Actions+To+Personalize+-+2+CUSTOM+CTA+LINK.pdf"
            },
            {
                name:"How to add Link Card in video action?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+9+Video+Actions+To+Personalize+-+3+LINK+CARD.pdf"
            },
            {
                name:"How to add Content Locker Lead Form in video action?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+9+Video+Actions+To+Personalize+-+4+CONTENT+LOCKER+LEAD+FORM.pdf"
            },
            {
                name:"How to add Custom Poll in video action?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+9+Video+Actions+To+Personalize+-+6+CUSTOM+POLL.pdf"
            },
            {
                name:"How to add Trigger Reel Form in video action?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+9+Video+Actions+To+Personalize+-+5+TRIGGER+REAL+FORM.pdf"
            },
            {
                name:"How to add Overlay Template in video action?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+9+Video+Actions+To+Personalize+-+7+OVERLAY+TEMPLATE.pdf"
            },
            {
                name:"How to add Lower Third in video action?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+9+Video+Actions+To+Personalize+-+8+LOWER+THIRD.pdf"
            },
            {
                name:"How to add Smiley Icons in video action?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+9+Video+Actions+To+Personalize+-+9+ICONS.pdf"
            },
            {
                name:"How Embed Code works (Edit and Personalize)?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+Embed+Code+Works+-+Edit+And+Personalize.pdf"
            },
            {
                name:"How to set Thumbnail (GIF or Upload) for the video Campaign?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Personalize+A+Video+-+II.pdf"
            },
            {
                name:"How to Configure Video Branding and Video Privacy?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+Video+Branding+And+Privacy.pdf"
            },
            {
                name:"How to change the Landing Page?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Change+A+Landing+Page+For+A+Campaign.pdf"
            },
            {
                name:"How to Copy the Sales/Landing page URL using Copy Link and Copy Link With Thumbnail and How it works?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Configure+Video+Branding+And+Privacy.pdf"
            },
            {
                name:"How to Configure Video Branding and Video Privacy?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+Copy+Link+Feature+Works.pdf"
            },
            {
                name:"How to Edit Landing Page Content?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Set+And+Edit+A+Landing+Page+For+A+Campaign.pdf"
            },
            {
                name:"How to Delete Campaign?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Delete+A+Campaign.pdf"
            },
            {
                name:"How to Export Leads?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/VidAmaze+-+How+To+Export+Leads.pdf"
            },
            {
                name:"How to check Poll Result?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/How+To+Check+POLL+Results+Of+A+Campaign.pdf"
            },
            {
                name:"How to Check Analytics and Report of the sales page or video?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/VidAmaze+-+How+To+Check+Analytics+And+Reports+Of+A+Campaign.pdf"
            },
            {
                name:"VidAmaze Dashboard Overview",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/VidAmazeDashboardOverview.pdf"
            },
            {
                name:"How To Install DFY Agency Kit Plugin ?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/DFY+Agency+Kit/1.+How+To+Install+DFY+Agency+Kit+Plugin.pdf"
            },
            {
                name:"How To Install DFY Agency Kit Theme Using Importer ?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/DFY+Agency+Kit/2.+How+To+Install+DFY+Agency+Kit+Theme+Using+Importer.pdf"
            },
            {
                name:"How To Edit And Customize DFY Agency Kit Theme ?",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/DFY+Agency+Kit/3.+How+To+Edit+And+Customize+DFY+Agency+Kit+Theme.pdf"
            },
            {
                name:"DFY Agency Theme Autoresponder Settings For Contact Page",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/DFY+Agency+Kit/4.+DFY+Agency+Theme+Autoresponder+Settings+For+Contact+Page.pdf"
            },
            {
                name:"DFY Agency Theme Backup Options and xml export",
                url:"",
                link:"https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/tutorials/DFY+Agency+Kit/5.+DFY+Agency+Theme+Backup+Options+and+xml+export.pdf"
            },
        ]


        res.send(tut)
    } catch (error) {
        console.log(error)
    }
}

module.exports = { insertApiKeys, fetchKeys, updateApiKeys, updateDetails, fetchTutorials }