const serialize = require('serialize-javascript');
const { sendPushnotification } = require('../services/web-push/webpush.service')
const db = require('../models/bootstrap')

const Op = db.Sequelize.Op;
const WebpushModel = db.webpush;




// return webpush rows
fetchStatus = async (req, res) => {

    try {
        const response = await WebpushModel.findAndCountAll({
            where: { user_id: req._user_id }
        })

        if (response) {
            res.send({ ...response, status: 200 })
        }
        else {
            res.send({ status: 404 })
        }
        // res.send(response)
    } catch (error) {
        res.send(error.message)
    }

}


// insert Webpush data and make visible
insertWebpush = async (req, res) => {
    try {
        // console.log(req._user_id)
        // res.send({ a: req._user_id })
        const subscription = req.body

        console.log(subscription)
        const respone = await WebpushModel.create({ subscriptions: serialize(subscription), user_id: req._user_id })

        const payload = JSON.stringify({
            title: 'Successfully activated',
            body: 'This is the body content',
            icon: 'https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/app-images/fav.png'

        })

        sendPushnotification(subscription, payload);

        res.send({ status: 200 })

    } catch (error) {

    }
}

// delete the webpush
deleteWebpush = async (req, res) => {
    try {
        const response = await WebpushModel.destroy({
            where: {
                user_id: req._user_id
            }
        })

        res.send({ status: 200 })
    } catch (error) {

    }
}


sendPush = async (req, res) => {

    try {
        const { user_id, status } = req.body
        const response = await WebpushModel.findOne({
            where: {
                user_id: user_id
            }
        })


        if (response) {



            // res.send(respone.subscriptions)
            var payload = {
                title: 'Testing Title',
                body: 'This is the body ',
                icon: 'https://engageleads-gallery.s3.us-west-2.amazonaws.com/VidAmaze/app-images/fav.png',

            }
            if (status === "is_playing") {
                payload.title = "One User just playing video"
                payload.image = req.body.poster
            } else if (status === "is_completed") {
                payload.title = "One User Watched full video"
                payload.image = req.body.poster
            }




            sendPushnotification(JSON.parse(response.subscriptions), JSON.stringify(payload));

            res.send(response.subscriptions)
        } else {
            res.status(404).send({ msg: "No data found" })
        }
    } catch (error) {
        console.log(error)
    }

}





module.exports = { fetchStatus, insertWebpush, deleteWebpush, sendPush }