const router = require('express').Router();

const { createUserSchema } = require('../../middleware/validators/users.validators')

const authController = require('../../controller/auth.controller');
const auth = require('../../middleware/auth');


router.get('/', (req, res) => {
    res.send({ msg: 'Hello Welcome' })
})


// Warriorlistener API Call For sales, refund and reccuring
router.post('/warriorlistener', authController.warriorlistener)
router.post('/tcartuser', authController.registerUser)

// Login users
router.post('/checkLoggedIn', auth, authController.isLoggedIn)
router.post('/login', authController.login)
router.post('/forgotPassword', authController.forgotPassword)
router.post('/passwordReset', authController.passwordReset)
router.post('/create', createUserSchema, authController.createUser)


// router.get("/hello", authController.isLoggedIn)




module.exports = router;

